import ngsolve as ng
from ngsolve import x, y, z, curl, Mesh, HCurl
from netgen.csg import OrthoBrick, unit_cube, CSGeometry, Pnt



box = OrthoBrick(Pnt(-1, -1, -1), Pnt(1, 1, 1)).bc("outer")
geo = CSGeometry()
geo.Add(box)

Ref_num = 3
Int_mesh_size =2

ngmesh = geo.GenerateMesh(maxh=Int_mesh_size)
mesh.GetBoundaries()


for i in range(Ref_num):
    if i > 0:
        ngmesh.Refine()
    mesh = Mesh(ngmesh)

    fes = HCurl(mesh, order=3, type1=True, dirichlet="outer")

    edges_no=mesh.nedge
    faces_no=mesh.nface
    elements_no=mesh.nv
    calcd_ndof = (mesh.nedge*3)+( mesh.nface*6)+( mesh.ne*3)
    print('#nedge=', mesh.nedge)
    print('#nface=', mesh.nface)
    print('#ne=', mesh.ne)
    print ("fes.ndof =", fes.ndof)
    print ("calculated_ndof =", calcd_ndof)
    print ("calculated_ndof-fes_ndof =", calcd_ndof-fes.ndof)
